#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
const Logger_1 = require("./common/Logger");
const commands_1 = require("./commands");
const SettingsManager_1 = require("./common/SettingsManager");
const settings = SettingsManager_1.SettingsManager.createSettings();
const pipeline = new commands_1.Pipeline(settings, new commands_1.CreateWebPackExtendFile(), new commands_1.PatchGulpFile(), new commands_1.PatchPackageJson(), new commands_1.PatchGitIgnoreFile());
Logger_1.logger.newLine();
pipeline.execute();
Logger_1.logger.success(chalk_1.default.green('All done!'));
Logger_1.logger.newLine();
Logger_1.logger.warning(chalk_1.default.bgRed('Now you should run \'npm install\'. When you\'re done, simply execute \'npm run serve\''));
//# sourceMappingURL=index.js.map